/*******************************************************************************
 
Autore : Mauro Laurenti
Versione : 1.1
 
Created on Date : 14/08/2007
Last update     : 25/01/2013

CopyRight 2006-2013 all rights are reserved

********************************************************
SOFTWARE LICENSE AGREEMENT
********************************************************

The usage of the supplied software imply the acceptance of the following license.

The software supplied herewith by Mauro Laurenti (the Author) is intended for
use solely and exclusively on Microchip PIC Microcontroller (registered mark).
The software is owned by the Author, and is protected under applicable
copyright laws. All rights are reserved.
Any use in violation of the foregoing restrictions may subject the
user to criminal sanctions under applicable laws, as well as to civil liability
for the breach of the terms and conditions of this license.
Commercial use is forbidden without a written acknowledgment with the Author.
Personal or educational use is allowed if the application containing the
following software doesn't aim to commercial use or monetary earning of any kind.

THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES,
WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED
TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE AUTHOR SHALL NOT,
IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR
CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.

********************************************************
PURPOSES
********************************************************

This library is written to support reading and writing the internal EEPROM
that many PIC microcntrollers have.
 
*******************************************************************************/

#ifndef intEEPROM_H
#define intEEPROM_H

#ifdef __XC8
#include <xc.h>
#endif

/**
 * This function writes a byte inside the internal EEPROM. 
 *
 * @param data Byte to write [min: 0, max: 255]
 *
 * @param address Address where the byte must be written [min: 0, max: 255]
 *
 * @return status 1: The byte has been properly written
 *                0: The byte has not been properly written
 *
 * @warning During the writing process the Interrupts are disabled. The old status is restored afterwards.
 *
 */

unsigned char write_internal_EEPROM (unsigned char address, unsigned char data);



/**
 * This function reads a byte from the internal EEPROM. 
 *
 *
 * @param address Address where the byte must be read [min: 0, max: 255]
 *
 * @return data Value read from the internal EEPROM.
 *
 */
unsigned char read_internal_EEPROM (unsigned char address);


#endif
